<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExistePendente StructType
 * @subpackage Structs
 */
class ExistePendente extends AbstractStructBase
{
    /**
     * The modulo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $modulo;
    /**
     * The filial
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $filial;
    /**
     * The tipodoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipodoc;
    /**
     * The serie
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $serie;
    /**
     * The numdoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $numdoc;
    /**
     * Constructor method for ExistePendente
     * @uses ExistePendente::setModulo()
     * @uses ExistePendente::setFilial()
     * @uses ExistePendente::setTipodoc()
     * @uses ExistePendente::setSerie()
     * @uses ExistePendente::setNumdoc()
     * @param string $modulo
     * @param string $filial
     * @param string $tipodoc
     * @param string $serie
     * @param int $numdoc
     */
    public function __construct($modulo = null, $filial = null, $tipodoc = null, $serie = null, $numdoc = null)
    {
        $this
            ->setModulo($modulo)
            ->setFilial($filial)
            ->setTipodoc($tipodoc)
            ->setSerie($serie)
            ->setNumdoc($numdoc);
    }
    /**
     * Get modulo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getModulo()
    {
        return isset($this->modulo) ? $this->modulo : null;
    }
    /**
     * Set modulo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $modulo
     * @return \StructType\ExistePendente
     */
    public function setModulo($modulo = null)
    {
        // validation for constraint: string
        if (!is_null($modulo) && !is_string($modulo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($modulo)), __LINE__);
        }
        if (is_null($modulo) || (is_array($modulo) && empty($modulo))) {
            unset($this->modulo);
        } else {
            $this->modulo = $modulo;
        }
        return $this;
    }
    /**
     * Get filial value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFilial()
    {
        return isset($this->filial) ? $this->filial : null;
    }
    /**
     * Set filial value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $filial
     * @return \StructType\ExistePendente
     */
    public function setFilial($filial = null)
    {
        // validation for constraint: string
        if (!is_null($filial) && !is_string($filial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($filial)), __LINE__);
        }
        if (is_null($filial) || (is_array($filial) && empty($filial))) {
            unset($this->filial);
        } else {
            $this->filial = $filial;
        }
        return $this;
    }
    /**
     * Get tipodoc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipodoc()
    {
        return isset($this->tipodoc) ? $this->tipodoc : null;
    }
    /**
     * Set tipodoc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipodoc
     * @return \StructType\ExistePendente
     */
    public function setTipodoc($tipodoc = null)
    {
        // validation for constraint: string
        if (!is_null($tipodoc) && !is_string($tipodoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tipodoc)), __LINE__);
        }
        if (is_null($tipodoc) || (is_array($tipodoc) && empty($tipodoc))) {
            unset($this->tipodoc);
        } else {
            $this->tipodoc = $tipodoc;
        }
        return $this;
    }
    /**
     * Get serie value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerie()
    {
        return isset($this->serie) ? $this->serie : null;
    }
    /**
     * Set serie value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serie
     * @return \StructType\ExistePendente
     */
    public function setSerie($serie = null)
    {
        // validation for constraint: string
        if (!is_null($serie) && !is_string($serie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serie)), __LINE__);
        }
        if (is_null($serie) || (is_array($serie) && empty($serie))) {
            unset($this->serie);
        } else {
            $this->serie = $serie;
        }
        return $this;
    }
    /**
     * Get numdoc value
     * @return int|null
     */
    public function getNumdoc()
    {
        return $this->numdoc;
    }
    /**
     * Set numdoc value
     * @param int $numdoc
     * @return \StructType\ExistePendente
     */
    public function setNumdoc($numdoc = null)
    {
        // validation for constraint: int
        if (!is_null($numdoc) && !is_numeric($numdoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($numdoc)), __LINE__);
        }
        $this->numdoc = $numdoc;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExistePendente
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
